int stepL = 9; //Globale Variablen, Definieren der Pins, die mit den zwei Schrittmotor-Treiber-Modulen verbunden sind,
int stepR = 6;//jedes Schrittmotor-Treiber-Modul hat jeweils zwei Pins, einen StepPin und einen DirectionPin,
int dirL = 5;// damit wir wissen, welche Pins benutzt werden, um die Pololu zu steuern.
int dirR = 7;
int druckTaster = 3;
int metalSensor = 2;
int STEPS_PER_ROTATION = 400;
boolean metalDetected = false;
boolean pressureDetected = false;

void setup() {   //Funktion wird einmal aufgerufen, um festzulegen, was benutzt werden soll und was damit passieren soll.

  Serial.begin(9600);
  pinMode (stepL, OUTPUT); //Schrittmotor 1
  pinMode (stepR, OUTPUT);// Schrittmotor 2
  pinMode (dirL, OUTPUT); //Schrittmotor 1
  pinMode (dirR, OUTPUT);// Schrittmotor 2
  digitalWrite (dirL, HIGH);
  digitalWrite (dirR, HIGH);
  pinMode (druckTaster, INPUT);
  attachInterrupt(digitalPinToInterrupt(metalSensor), onMetal, LOW);
 // attachInterrupt(digitalPinToInterrupt(druckTaster), onTaster, FALLING);
}

void loop() {  
  pressureDetected = digitalRead(3);
  Serial.print("Knopf: "+String(pressureDetected));
  Serial.print("\t");
  Serial.println("Sensor: "+String (metalDetected));
  if (pressureDetected == true && metalDetected == true) {
    rotateWheels(5, true);
  }

  if (pressureDetected == true && metalDetected == false)
  {
   rotateWheels(5, false);
  }

  //  if (digitalRead (druckTaster) == HIGH) {
  //    Serial.println("pressed!");
  //
  //    if (metalDetected) {
  //      Serial.println("metall!");
  //      rotateWheels(4, true);
  //    }
  //    else {
  //      Serial.println("no metall!");
  //      rotateWheels(4, false);
  //    }
  //    metalDetected = false;
  //    delay (5000);
  //
  //  } else {
  //    metalDetected = false;
  //  }
  //bei "true" fahren die Schrittmotoren nach vorne, bei "false" nach hinten,
  // hier wird nur die Bewegung selbst festgelegt, dass sie sich überhaupt bewegen und Richtung

}

// macht 1 Schritt mit dem bestimmten Motor in angegebene Richtung "true" oder "false", je nachdem, was angegeben wurde
void stepMove (int directionPin, int stepPin, boolean forward) { //boolean steht für true oder false
  digitalWrite(directionPin, forward);
  digitalWrite (stepPin, HIGH);
  delay(1);
  digitalWrite (stepPin, LOW);
  delay (1);
}

// sobald ein Signal kommt (onSignal) wird alles unterbrochen und die Funktion "interrupt" kann beginnen

//dreht beide Räder in die angebene Richtung und die Anzahl der Umdrehungen
void rotateWheels(int rotations, boolean forward) {
  for (int i = 0; i < rotations * STEPS_PER_ROTATION; i = i + 1)
  {
    stepMove(dirL, stepL, forward);
    stepMove(dirR, stepR, forward);
  }
}





boolean metalDetector() {
  boolean metalDetected = !digitalRead (2);
  return metalDetected; //gibt ein True zurück, wenn das Metall ist oder ein false, wenn es kein Metall ist
  //attachInterrupt(digitalPinToInterrupt(2), onSignal, CHANGE);
}


void onTaster () {
  pressureDetected = digitalRead(druckTaster);
}


void onMetal() {
  metalDetected = true;
}
